import { EngineInterface, NodeInterface, Selector } from '../types';
export declare type Options = {
    engine: EngineInterface;
    lang?: string;
    tabIndex?: number;
    className?: string | Array<string>;
    placeholder?: string;
};
declare class Container {
    #private;
    private options;
    private node;
    private _focused;
    constructor(selector: Selector, options: Options);
    _init(): void;
    init(): void;
    isFocus(): boolean;
    getNode(): NodeInterface;
    setReadonly(readonly: boolean): void;
    showPlaceholder(): void;
    hidePlaceholder(): void;
    destroy(): void;
}
export default Container;
