import { EventInterface, EventListener } from '../types/node';
/**
 * 事件
 */
declare class Event implements EventInterface {
    readonly listeners: {
        [x: string]: EventListener[];
    };
    /**
     * 绑定事件
     * @param {string} eventType 事件名称
     * @param {Function} listener 事件处理方法
     * @param {boolean} rewrite 是否重写事件
     */
    on(eventType: string, listener: EventListener, rewrite?: boolean): void;
    /**
     * 解除绑定
     * @param {string} eventType
     * @param listener
     */
    off(eventType: string, listener: EventListener): void;
    /**
     * 触发事件
     * @param eventType 事件类型
     * @param args 事件参数
     */
    trigger(eventType: string, ...args: any): undefined;
}
export default Event;
