import { EditorInterface, NodeIdInterface, NodeInterface, SchemaRule } from '../types';
declare class NodeId implements NodeIdInterface {
    #private;
    editor: EditorInterface;
    constructor(editor: EditorInterface);
    init(): void;
    /**
     * 根据规则获取需要为节点创建 data-id 的标签名称集合
     * @returns
     */
    getRules(): {
        [key: string]: SchemaRule[];
    };
    /**
     * 给节点创建data-id
     * @param node 节点
     * @returns
     */
    create(node: Node | NodeInterface): string;
    /**
     * 在根节点内为需要创建data-id的子节点创建data-id
     * @param root 根节点
     */
    generateAll(root?: Element | NodeInterface | DocumentFragment, force?: boolean): void;
    /**
     * 为节点创建一个随机data-id
     * @param node 节点
     * @param isCreate 如果有，是否需要重新创建
     * @returns
     */
    generate(node: Node | NodeInterface, force?: boolean): string | undefined;
    /**
     * 判断一个节点是否需要创建data-id
     * @param name 节点名称
     * @returns
     */
    isNeed(node: NodeInterface): boolean;
}
export default NodeId;
