import { EngineInterface } from '../types/engine';
import { Op, Path } from 'sharedb';
import { ConsumerInterface, RemoteAttr, RemotePath, TargetOp } from '../types/ot';
import { NodeInterface } from '../types/node';
import { RangePath } from '../types';
declare class Consumer implements ConsumerInterface {
    private engine;
    constructor(engine: EngineInterface);
    getElementFromPath: (node: Node | NodeInterface, path: import("sharedb/lib/sharedb").Path) => {
        startNode: Node;
        startOffset: number;
        endNode: Node;
        endOffset: number;
    };
    fromRemoteAttr(attr: RemoteAttr): {
        container: Node | null;
        offset: number;
    } | undefined;
    getSideText(node: NodeInterface, offset: number): RemoteAttr | undefined;
    setAttribute(root: NodeInterface, path: Path, attr: string, value: string, isRemote?: boolean): NodeInterface | undefined;
    removeAttribute(root: NodeInterface, path: Path, attr: string): NodeInterface;
    insertNode(root: NodeInterface, path: Path, value: string | Op[] | Op[][], isRemote?: boolean): NodeInterface | undefined;
    deleteNode(root: NodeInterface, path: Path, isRemote?: boolean): NodeInterface | undefined;
    insertText(root: NodeInterface, path: Path, offset: number, text: string): NodeInterface | undefined;
    deleteText(root: NodeInterface, path: Path, offset: number, text: string): NodeInterface | undefined;
    handleOperation(op: TargetOp, isRemote?: boolean): NodeInterface | undefined;
    handleRemoteOperations(ops: Op[]): NodeInterface[];
    handleSelfOperations(ops: Op[]): NodeInterface[];
    handleIndex(ops: Op[], applyNodes: NodeInterface[]): void;
    setRangeAfterOp(op: TargetOp): void;
    getRangeRemotePath(): RemotePath | undefined;
    setRangeByRemotePath(path: RemotePath): void;
    setRangeByPath(path: {
        start: RangePath;
        end: RangePath;
    }): void;
}
export default Consumer;
