import { EventEmitter2 } from 'eventemitter2';
import { Doc, Op } from 'sharedb';
import { EngineInterface } from '../types/engine';
import { ConsumerInterface, Attribute, Member, OTInterface, SelectionInterface } from '../types/ot';
import './index.css';
declare class OTModel extends EventEmitter2 implements OTInterface {
    private engine;
    private members;
    private currentMember?;
    private waitingOps;
    private clientId;
    selection: SelectionInterface;
    private rangeColoring;
    consumer: ConsumerInterface;
    private mutation;
    private doc;
    constructor(engine: EngineInterface);
    private updateRangeColoringPosition;
    private applyWaitingOps;
    colors: string[];
    initLocal(): void;
    initRemote(doc: Doc, defaultValue?: string): void;
    handleChange(ops: Op[]): void;
    submitOps(ops: Op[]): void;
    apply(ops: Op[]): void;
    syncValue(defaultValue?: string): void;
    startMutation(): void;
    stopMutation(): void;
    startMutationCache(): void;
    submitMutationCache(): void;
    destroyMutationCache(): void;
    /**
     * 获取缓存的记录
     * @returns
     */
    getCaches(): MutationRecord[];
    getColors(): string[];
    setColors(colors: string[]): void;
    setMemberColor(member: Member): void;
    getMembers(): Member[];
    setMembers(members: Array<Member>): void;
    addMember(member: Member): void;
    removeMember(member: Member): void;
    setCurrentMember(member: Member): void;
    getCurrentMember(): Member | undefined;
    renderSelection(attributes: Array<Attribute>, isDraw?: boolean): void;
    updateSelection(): void;
    initSelection(): void;
    destroy(): void;
}
export default OTModel;
