import { EventEmitter2 } from 'eventemitter2';
import { Doc, Op } from 'sharedb';
import { EngineInterface } from '../types/engine';
import { NodeInterface } from '../types/node';
import { DocInterface, MutationInterface } from '../types/ot';
declare type Options = {
    engine: EngineInterface;
    doc?: DocInterface | Doc;
};
declare class Mutation extends EventEmitter2 implements MutationInterface {
    private node;
    private engine;
    private doc?;
    private isStopped;
    private observer;
    private producer;
    private isCache;
    private cache;
    constructor(node: NodeInterface, options: Options);
    setDoc(doc: DocInterface | Doc): void;
    start(): void;
    stop(): void;
    /**
     * 开始缓存操作
     */
    startCache(): void;
    /**
     * 将缓存提交处理，最后停止缓存
     */
    submitCache(): void;
    /**
     * 将缓存情况注销掉
     */
    destroyCache(): void;
    /**
     * 获取缓存的记录
     * @returns
     */
    getCaches(): MutationRecord[];
    onChange(ops: Op[]): void;
}
export default Mutation;
