import { EngineInterface } from '../types/engine';
import { RangeInterface } from '../types/range';
import { NodeInterface } from '../types/node';
import { Attribute, CursorRect, Member, RangeColoringInterface } from '../types/ot';
import { DrawStyle, TinyCanvasInterface } from '../types/tiny-canvas';
import { CardInterface } from '../types/card';
declare class RangeColoring implements RangeColoringInterface {
    private engine;
    private root;
    private hideCursorInfoTimeoutMap;
    constructor(engine: EngineInterface);
    destroy(): void;
    getRectWithRange(node: NodeInterface, range: RangeInterface): DOMRect;
    isWrapByRange(range: RangeInterface): boolean;
    drawSubRang(node: NodeInterface, canvas: TinyCanvasInterface, range: RangeInterface, style: DrawStyle): void;
    drawBackground(range: RangeInterface, options: {
        uuid: string;
        color: string;
    }): RangeInterface[];
    getNodeRect(node: NodeInterface, rect: DOMRect): DOMRect;
    getCursorRect(selector: RangeInterface | NodeInterface, leftSpace?: number): CursorRect;
    setCursorRect(node: NodeInterface, rect: CursorRect): void;
    showCursorInfo(node: NodeInterface, member: Member): void;
    hideCursorInfo(node: NodeInterface): void;
    drawCursor(selector: RangeInterface | NodeInterface, member: Member): NodeInterface | undefined;
    drawCard(node: NodeInterface, cursor: NodeInterface, member: Member): void;
    setCardSelectedByOther(card: CardInterface, member?: Member): void | NodeInterface;
    setCardActivatedByOther(card: CardInterface, member?: Member): void | NodeInterface;
    drawRange(range: RangeInterface, member: Member): void;
    updateBackgroundPosition(): void;
    updateCursorPosition(): void;
    updateCardPosition(): void;
    updatePosition(): void;
    updateBackgroundAlpha(range: RangeInterface): void;
    render(data: Array<Attribute>, members: Array<Member>, idDraw: boolean): void;
}
export default RangeColoring;
