import { EditorInterface } from '../types/engine';
import { PluginEntry, PluginInterface, PluginModelInterface, PluginOptions } from '../types/plugin';
import Plugin from './base';
import ElementPlugin from './element';
import BlockPlugin, { isBlockPlugin } from './block';
import InlinePlugin, { isInlinePlugin } from './inline';
import ListPlugin from './list';
import MarkPlugin, { isMarkPlugin } from './mark';
declare class PluginModel implements PluginModelInterface {
    protected data: {
        [k: string]: PluginEntry;
    };
    components: {
        [k: string]: PluginInterface;
    };
    protected editor: EditorInterface;
    constructor(editor: EditorInterface);
    init(plugins: Array<PluginEntry>, config: {
        [k: string]: PluginOptions;
    }): void;
    add(clazz: PluginEntry, options?: PluginOptions): void;
    each(callback: (name: string, clazz: PluginEntry, index?: number) => boolean | void): void;
}
export default PluginModel;
export { Plugin, ElementPlugin, MarkPlugin, InlinePlugin, BlockPlugin, ListPlugin, isBlockPlugin, isInlinePlugin, isMarkPlugin, };
