import ElementPluginEntry from './element';
import { InlineInterface, NodeInterface, PluginInterface } from '../types';
declare abstract class InlineEntry<T extends {} = {}> extends ElementPluginEntry<T> implements InlineInterface {
    readonly kind: string;
    /**
     * 标签名称
     */
    abstract readonly tagName: string;
    /**
     * Markdown 规则，可选
     */
    readonly markdown?: string;
    init(): void;
    execute(...args: any): void;
    queryState(): boolean | string[] | undefined;
    /**
     * 是否触发执行增加当前inline标签包裹，否则将移除当前inline标签的包裹
     * @param args 在调用 command.execute 执行插件传入时的参数
     */
    isTrigger?(...args: any): boolean;
    /**
     * 解析markdown
     * @param event 事件
     * @param text markdown文本
     * @param node 触发节点
     */
    triggerMarkdown(event: KeyboardEvent, text: string, node: NodeInterface): false | undefined;
    checkMarkdown(node: NodeInterface): {
        reg: RegExp;
        match: RegExpExecArray | null;
    } | undefined;
    pasteMarkdown(node: NodeInterface): void;
}
export default InlineEntry;
export declare const isInlinePlugin: (plugin: PluginInterface) => plugin is InlineInterface;
