import { AjaxInterface, AjaxOptions, SetupOptions } from '../../types/request';
declare class Ajax implements AjaxInterface {
    private options;
    private headNode?;
    private request?;
    private isAborted;
    private isTimeout;
    private timeout?;
    private callbackData?;
    private callbackPrefix;
    private uuid;
    private promise?;
    private __resolve?;
    private __reject?;
    /**
     * 设置全局选项
     * @param options 选项
     */
    static setup: (options: SetupOptions) => void;
    constructor(options: AjaxOptions | string);
    initPromise(): void;
    init(): void;
    abort(): void;
    defaultXHR(): any;
    succeed(): boolean;
    noop(): void;
    handleReadyState(success: (request?: XMLHttpRequest) => void, error: (statusText: string, request?: XMLHttpRequest) => void): void;
    setHeaders(request: XMLHttpRequest): void;
    setCredentials(request: XMLHttpRequest): void;
    generalCallback(data: any): void;
    getCallbackPrefix(id: string | number): string;
    handleJsonp(url: string, success: (data: any) => void, error: (errorMsg: string) => void): XMLHttpRequest | undefined;
    getRequest(success: (data: any) => void, error: (errorMsg: string, request?: XMLHttpRequest) => void): XMLHttpRequest | undefined;
    getType(type?: string | null): "xml" | "html" | "json" | "js" | undefined;
    triggerSuccess(request: XMLHttpRequest): void;
    triggerError(errorMsg: string, request?: XMLHttpRequest): void;
    triggerComplete(request: XMLHttpRequest | Error): void;
    retry(): void;
    then(success: (data: any) => void, fail?: (reason?: any) => void): Promise<void> | undefined;
    always(fn: (data: any) => void): Promise<void> | undefined;
    fail(fn: (reason?: any) => void): Promise<any> | undefined;
    catch(fn: (reason?: any) => void): Promise<any> | undefined;
}
export default Ajax;
