import { RequestInterface, AjaxOptions, UploaderOptions, OpenDialogOptions } from '../types';
import Ajax from './ajax';
import Uploader, { getExtensionName, getFileSize } from './uploader';
declare class Request implements RequestInterface {
    ajax(options: AjaxOptions | string): Ajax;
    upload(options: UploaderOptions, files: Array<File>, name?: string): Promise<void>;
    getFiles(options?: OpenDialogOptions): Promise<File[]>;
}
export { getExtensionName, Ajax, Uploader, getFileSize };
export default Request;
