import { DrawOptions, TinyCanvasInterface } from '../types/tiny-canvas';
declare type Options = {
    container?: HTMLElement;
    limitHeight?: number;
    canvasCache?: Array<HTMLCanvasElement>;
    canvasCount?: number;
};
declare class TinyCanvas implements TinyCanvasInterface {
    private options;
    constructor(options: Options);
    private removeCanvas;
    private getCanvas;
    resize(width: number, height: number): void;
    private handleSingleRect;
    drawRect(options: DrawOptions): void;
    private handleRect;
    getImageData(options: DOMRect): ImageData | undefined;
    clearRect(options: DOMRect): void;
    clear(): void;
    destroy(): void;
}
export default TinyCanvas;
