import { EventInterface, NodeInterface, Selector, EventListener, NodeModelInterface } from './types/node';
import { ViewInterface, ContentViewOptions } from './types/view';
import { CardModelInterface } from './types/card';
import { PluginModelInterface } from './types/plugin';
import { SchemaInterface } from './types/schema';
import { ConversionInterface } from './types/conversion';
import { ClipboardInterface } from './types/clipboard';
import { LanguageInterface } from './types/language';
import { CommandInterface, MarkModelInterface, NodeIdInterface, RequestInterface } from './types';
import { BlockModelInterface } from './types/block';
import { InlineModelInterface } from './types/inline';
import { ListModelInterface } from './types/list';
declare class View implements ViewInterface {
    #private;
    private options;
    readonly kind = "view";
    root: NodeInterface;
    language: LanguageInterface;
    container: NodeInterface;
    card: CardModelInterface;
    plugin: PluginModelInterface;
    node: NodeModelInterface;
    list: ListModelInterface;
    mark: MarkModelInterface;
    inline: InlineModelInterface;
    block: BlockModelInterface;
    clipboard: ClipboardInterface;
    event: EventInterface;
    schema: SchemaInterface;
    conversion: ConversionInterface;
    command: CommandInterface;
    request: RequestInterface;
    nodeId: NodeIdInterface;
    constructor(selector: Selector, options?: ContentViewOptions);
    setScrollNode(node?: HTMLElement): void;
    get scrollNode(): NodeInterface | null;
    on(eventType: string, listener: EventListener, rewrite?: boolean): this;
    off(eventType: string, listener: EventListener): this;
    trigger(eventType: string, ...args: any): any;
    render(content: string, trigger?: boolean): void;
    messageSuccess(message: string): void;
    messageError(error: string): void;
    messageConfirm(message: string): Promise<boolean>;
}
export default View;
